/*
procesorowiec@gmail.com
*/

//---.h file---

#ifndef AVT5636_H
#define AVT5636_H

#include "Arduino.h"

//---version---
#define AVT5636LIB_VER	"1.0"

//---outputs---
//outputs
#define OUTPUT1_PIN		10
#define OUTPUT2_PIN 	11
#define OUTPUT3_PIN		12
#define OUTPUT4_PIN		13
#define OUTPUT_ACTIVE_LEVEL		HIGH
#define OUTPUT_IDLE_LEVEL		LOW

//leds
#define LED1_PIN		10
#define LED2_PIN		11
#define LED3_PIN		12
#define LED4_PIN		13
#define LED_ACTIVE_LEVEL		HIGH
#define LED_IDLE_LEVEL			LOW

//pulse
#define PULSE1_PIN		5
#define PULSE2_PIN		6
#define PULSE_ACTIVE_LEVEL		HIGH
#define PULSE_IDLE_LEVEL		LOW

//buzzer
#define BUZZER_PIN		9
#define BUZZER_ACTIVE_LEVEL		HIGH
#define BUZZER_IDLE_LEVEL		LOW

//---inputs---
//buttons
#define S1_PIN			3
#define S2_PIN			4
#define S3_PIN			7
#define S4_PIN			8
#define SWITCH_ACTIVE_LEVEL		LOW
#define SWITCH_IDLE_LEVEL		HIGH

//inputs
#define INPUT1_PIN		A0
#define INPUT2_PIN		A1
#define INPUT3_PIN		A2
#define INPUT4_PIN		A3

//components
#define TOUCH_PIN		A0
#define VREG_PIN		A1
#define TEMP_PIN		A2
#define FOTO_PIN		A3
#define VIN_PIN			A1

//analog
#define ADC_VREG_CH		A1
#define ADC_VIN_CH		A1
#define ADC_TEMP_CH		A2
#define ADC_FOTO_CH		A3

//---interfaces---
//serial
#define RX_PIN			0
#define TX_PIN			1

//i2c - lcd
#define SDA_PIN			A4
#define SCL_PIN			A5

//1w /int0
#define ONEWIRE_PIN		2
#define INT0_PIN		2
#define INT0_ACTIVE_LEVEL		LOW
#define INT0_IDLE_LEVEL			HIGH

//lcd
#define SERIAL_LCD_PIN			1
#define SOFTSERIAL_LCD_PIN		2

//---for methods---
#define AVT5636_O1		1
#define AVT5636_O2		2
#define AVT5636_O3		3
#define AVT5636_O4		4

#define AVT5636_L1		1
#define AVT5636_L2		2
#define AVT5636_L3		3
#define AVT5636_L4		4

#define AVT5636_I1		1
#define AVT5636_I2		2
#define AVT5636_I3		3
#define AVT5636_I4		4

#define AVT5636_S1		1
#define AVT5636_S2		2
#define AVT5636_S3		3
#define AVT5636_S4		4

#define AVT5636_A1		1
#define AVT5636_A2		2
#define AVT5636_A3		3
#define AVT5636_A4		4

#define AVT5636_TOUCH	1
#define AVT5636_VREG	2
#define AVT5636_VIN		2
#define AVT5636_TEMP	3
#define AVT5636_FOTO	4


//---my class---
class AVT5636{
  
  public:
    AVT5636();
    void init();
	
    void outOn(int num);
    void outOff(int num);
    void outPulse(int num, int tIme);
    
	bool outGet(int num);
    int outputsGet();
    void outputsSet(int state);
	
    void ledOn(int num);
    void ledOff(int num);
    void ledPulse(int num, int tIme);
	
	void pulse1Set(int val);
	void pulse2Set(int val);
	
    void buzzerOn();
    void buzzerOff();
	void buzzerPulse(int tIme);
	
    int getButtons();
	int getInputs();
	bool getInput(int num);

	int getInputAdc(int num);
	int getInputVoltage(int num);
	int getInputPercent(int num);
	
	int getTouch();
    int getVreg();
    int getLight();
    int getTemp();
	int getVin();
	int getVin10();
	
	void lcdPrint(String str);
	void lcdPosition(int y, int x);
	void lcdClear();
	void lcdSpecChar(int index, char *src);
	void lcdMessage(int y, int x, String str);

  private:
	String version;	
};

#endif
