#include <AVT5636lib.h>
#include <Servo.h>

AVT5636 myBoard;
Servo myServo;

int mode = 0;
int button = 0;
int refresh = 0;
int period = 0;
int pulseVal = 0;
int pulseDir = 0;

String value;
int valuesPeriod = 0;


void setup() {
  myBoard.init(); 
  myBoard.lcdMessage(1,5,"Hello");
  myServo.attach(PULSE2_PIN);
}

void loop() {
  
  //---buttons---
  int i;
  i = myBoard.getButtons();
  if ((i > 0) && (i != button)){
    button = i;
    refresh = 1;
  }

  //---actions---
  if (refresh > 0){
    myBoard.buzzerPulse(15);
    mode = button;
    refresh = 0;

    switch (mode){
      case AVT5636_S1:
        myBoard.lcdMessage(1,3,"Touch sensor  ");
      break;  
      case AVT5636_S2:
        myBoard.lcdMessage(1,3,"Potentiometer ");
      break;  
      case AVT5636_S3:
        myBoard.lcdMessage(1,3,"Temperature   ");
      break;  
      case AVT5636_S4:
        myBoard.lcdMessage(1,3,"Light sensor  ");
      break;  
    }
  }
  
  //---modes---
  valuesPeriod++;
  if (valuesPeriod >= 5){
    valuesPeriod = 0;
    switch (mode){
      case 0:
        value = "---";
      break;
      case AVT5636_S1:
        if (myBoard.getTouch() > 0){
          value = "active";
        } else {
          value = "idle";
        }
      break;  
      case AVT5636_S2:
        value = (String)myBoard.getVreg();
        value += "mV";
      break;  
      case AVT5636_S3:
        myBoard.getTemp();
        value = (String)myBoard.getTemp();
        value += "\1C";       //char 1 is degree char
      break;  
      case AVT5636_S4:
        value = (String)myBoard.getLight();
        value += "%";
      break;  
    }    

    value = value + "     ";   //clear prev val
    myBoard.lcdMessage(2,5,value);
  }

  //---analog out---
  if (pulseVal <= 0) pulseDir = 0;
  if (pulseVal >= 255) pulseDir = 1;
  
  if (pulseDir == 0){
    pulseVal += 4;
  } else {
    pulseVal -= 4;
  }
  myBoard.pulse1Set(pulseVal);

  //---servo out---
  myServo.write((myBoard.getInputAdc(AVT5636_VREG) / 8) + 25);

  //---leds---
  if (period >= 20) period = 0;  
  if (period == 0) myBoard.ledOn(mode);
  if (period == 10) myBoard.outputsSet(0);  //clear any leds
  delay(20);
  period++;
}
